﻿using System;
using System.Collections;
using System.Data;
using System.Text;
using System.Web;
using System.Web.UI;
using G2.UI.Common;
using Infragistics.Web.UI.GridControls;

namespace SCM.Web.UI.Delivery
{
    public partial class DO_Search : G2.Pages.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            try
            {

                DefaultScript();

                PopUpScript();

                if (!IsPostBack)
                {
                    SettingDefalut();

                    FillDropDownList();


                    this.SearchMethod();
                }
            }
            catch (Exception Ex)
            {
                //this.AlertMessage(Ex.Message);
            }


        }

        #region default Script

        private void DefaultScript()
        {
            ddlConfirm.Attributes.Add("onchange", "document.all['Btn_Search'].click();");

            
        }

        #endregion

        #region PopUp Script 

        private void PopUpScript()
        {
            
        }

        #endregion

        #region SettingDefalut
        private void SettingDefalut()
        {
            DateTime Dt = new DateTime(DateTime.Now.Year, DateTime.Now.Month, 1);
            DatFrom.Date = Dt;
            DatTo.Date = DateTime.Today;


        }

        #endregion

        #region FillDropDownList
        private void FillDropDownList()
        {
        }
        #endregion 

      

        #region SearchMethod
        private void SearchMethod()
        {
            DataSet Ds = null;

            string strfromdt = DatFrom.Date.ToString("yyyyMMdd");
            string strtodt = DatTo.Date.ToString("yyyyMMdd");
            string strconfirm_yn = ddlConfirm.SelectedValue.ToString();

            
            StringBuilder SelectQuery = null;

            try
            {
                SelectQuery = new StringBuilder();

                SelectQuery.AppendFormat(@"

SELECT 
H.CD_COMPANY
, H.NO_PO
, L.NO_LINE
, H.NO_PO +  CONVERT(VARCHAR(5), L.NO_LINE) AS KEYFIELD
, CASE WHEN ISNULL(H.DT_PO,'')='' OR  LEN(H.DT_PO) <> 8 THEN '' ELSE LEFT(H.DT_PO,4) +'-'+ SUBSTRING(H.DT_PO,3,2) +'-'+RIGHT(H.DT_PO,2) END AS DT_PO
,D.CD_DEPT
, D.NM_DEPT
, H.NO_EMP
, E.NM_KOR
, P.NM_TPPO
, L.CD_ITEM
, I.NM_ITEM
, I.STND_ITEM
, L.CD_UNIT_MM
, L.ST_PO
, L.QT_PO
, PL.QT_REQ
, PR.QT_REV
, H.DC_RMK2
FROM PU_POL L
JOIN PU_POH H ON H.CD_COMPANY = L.CD_COMPANY AND H.NO_PO = L.NO_PO
LEFT OUTER JOIN MA_PITEM I ON L.CD_COMPANY = I.CD_COMPANY AND L.CD_ITEM = I.CD_ITEM AND L.CD_PLANT = I.CD_PLANT
LEFT OUTER JOIN MA_EMP E ON H.CD_COMPANY = E.CD_COMPANY AND H.NO_EMP = E.NO_EMP
LEFT OUTER JOIN MA_DEPT D ON H.CD_COMPANY = D.CD_COMPANY AND E.CD_DEPT = D.CD_DEPT
LEFT OUTER JOIN PU_TPPO P ON H.CD_COMPANY = P.CD_COMPANY AND H.CD_TPPO = P.CD_TPPO
LEFT OUTER JOIN V_PJ_RCV PL ON L.CD_COMPANY= PL.CD_COMPANY AND L.NO_PO = PL.NO_PO AND L.NO_LINE = PL.NO_LINE_PO
LEFT OUTER JOIN V_PJ_REV PR ON L.CD_COMPANY= PR.CD_COMPANY AND L.NO_PO = PR.NO_PO AND L.NO_LINE = PR.NO_POLINE
WHERE H.CD_COMPANY = {0}
AND H.CD_PARTNER = {1}
AND (H.DT_PO >= {2} OR {2} = '' OR {2} IS NULL)
AND (H.DT_PO <= {3} OR {3} = '' OR {3} IS NULL)
AND (CASE WHEN ISNULL(PR.NO_PO,'') <> '' THEN '4' 
ELSE CASE WHEN ISNULL(PL.NO_PO,'') <> '' THEN '3' 
  ELSE CASE WHEN ISNULL(H.FG_WEB,'N') = 'Y' THEN '2' 
  ELSE '1'
END 
END 
END  = {4} OR {4} = '' OR {4} IS NULL)
AND FG_POST IN ('R', 'S')

", Func.I(Gobj.CD_COMPANY), Func.I(Gobj.CD_PARTNER), Func.I(strfromdt), Func.I(strtodt), Func.I(strconfirm_yn));
                Ds = new DataSet();
                Ds = Func.GetDataSetQuery(SelectQuery.ToString());

              
                WebDataGrid1.DataSource = Ds.Tables[0];
                WebDataGrid1.DataBind();
                
            }
            catch (Exception Ex)
            {
                throw new Exception(Ex.Message);
            }

            finally
            {
                if (Ds != null)
                    Ds.Dispose();
            }
        }

        #endregion

        #region Event


        protected void Btn_Search_Click(object sender, ImageClickEventArgs e)
        {
            try
            {
                SearchMethod();
            }
            catch (Exception Ex)
            {
                //this.AlertMessage(Func.GetMessage(Gobj.CdLang, Ex.Message));
            }
        }

        protected void Btn_Find_Click(object sender, EventArgs e)
        {
            try
            {
                SearchMethod();
            }
            catch (Exception Ex)
            {
                //this.AlertMessage(Func.GetMessage(Gobj.CdLang, Ex.Message));
            }
        }


        protected void Btn_Excel_Click(object sender, ImageClickEventArgs e)
        {
            try
            {// customize the grid for export
                
                // trigger export



                WebExcelExporter1.DataExportMode = Infragistics.Web.UI.GridControls.DataExportMode.AllDataInDataSource;
                WebExcelExporter1.WorkbookFormat = Infragistics.Documents.Excel.WorkbookFormat.Excel97To2003;
                WebExcelExporter1.EnableStylesExport = true;
                WebExcelExporter1.DownloadName = HttpUtility.UrlEncode("PurchaseSearch");

                WebDataGrid1.Behaviors.SummaryRow.Enabled = false;
                WebExcelExporter1.Export(WebDataGrid1);
                WebDataGrid1.Behaviors.SummaryRow.Enabled = true;

            }
            catch (Exception Ex)
            {
                //this.AlertMessage(Func.GetMessage(Gobj.CdLang, Ex.Message));
            }
        }



        protected void Sorting_ColumnSorted(object sender, SortingEventArgs e)
        {
            if (e.SortedColumns.Count > 0)
            {
                SortedColumnInfo column = e.SortedColumns[0];
            }
        }


        protected void Btn_PDF_Click(object sender, ImageClickEventArgs e)
        {
            try
            {
                
                ////configure exporter
                //WebDocumentExporter1.Format= Infragistics.Web.UI.GridControls.FileFormat.PDF;
                //WebDocumentExporter1.DownloadName = "DO_Search01.pdf";
                //WebDocumentExporter1.TargetPaperOrientation = Infragistics.Documents.Reports.Report.PageOrientation.Landscape;
                //WebDocumentExporter1.Export(this.WebDataGrid1);
            }
            catch (Exception Ex)
            {
                //this.AlertMessage(Func.GetMessage(Gobj.CdLang, Ex.Message));
            }

        }


        #endregion


      
       
    }
}
